Index: trunk/kernel/fs/devfs.c
===================================================================
--- trunk/kernel/fs/devfs.c	(revision 612)
+++ trunk/kernel/fs/devfs.c	(revision 614)
@@ -110,8 +110,8 @@
 assert( (error == 0) , "cannot create <dev>\n" );
 
-#if DEBUG_DEVFS_INIT
+#if DEBUG_DEVFS_GLOBAL_INIT
 uint32_t   cycle = (uint32_t)hal_get_cycles();
 thread_t * this  = CURRENT_THREAD;
-if( DEBUG_DEVFS_INIT < cycle )
+if( DEBUG_DEVFS_GLOBAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <dev> inode / cycle %d\n",
 __FUNCTION__, this->process->pid, this->trdid, cycle );
@@ -134,7 +134,7 @@
 assert( (error == 0) , "cannot create <external>\n" );
 
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_GLOBAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_GLOBAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <external> inode / cycle %d\n",
 __FUNCTION__, this->process->pid, this->trdid, cycle );
@@ -159,4 +159,12 @@
     error_t       error;
 
+#if DEBUG_DEVFS_LOCAL_INIT 
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
+printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, cycle );
+#endif
+
     // create "internal" directory 
     snprintf( node_name , 16 , "internal_%x" , local_cxy );
@@ -177,8 +185,7 @@
 assert( (error == 0) , "cannot create <external>\n" );
 
-#if DEBUG_DEVFS_INIT 
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-thread_t * this  = CURRENT_THREAD;
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT 
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <%s> inode in cluster %x / cycle %d\n",
 __FUNCTION__, this->process->pid, this->trdid, node_name, local_cxy, cycle );
@@ -209,7 +216,7 @@
         hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <mmc> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, local_cxy, cycle );
@@ -244,7 +251,7 @@
             hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread [%x,%x] created <dma[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );
@@ -277,7 +284,7 @@
             hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <iob> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, local_cxy, cycle );
@@ -310,7 +317,7 @@
             hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <pic> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, local_cxy, cycle );
@@ -345,7 +352,7 @@
                 hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <txt_rx[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );
@@ -381,7 +388,7 @@
                 hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT 
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT 
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <txt_tx[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );
@@ -417,7 +424,7 @@
                 hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <ioc[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );
@@ -453,7 +460,7 @@
                 hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <fbf[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );
@@ -489,7 +496,7 @@
                 hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
  
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <nic_rx[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );
@@ -525,7 +532,7 @@
                 hal_remote_spt( XPTR( inode_cxy , &inode_ptr->extend ) , chdev_ptr );
         
-#if DEBUG_DEVFS_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEVFS_INIT < cycle )
+#if DEBUG_DEVFS_LOCAL_INIT
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEVFS_LOCAL_INIT < cycle )
 printk("\n[%s] thread[%x,%x] created <nic_tx[%d]> inode in cluster %x\n",
 __FUNCTION__, this->process->pid, this->trdid, channel, local_cxy, cycle );